/*
Pps -- Plot for PostScript printer

Library for PostScript output
1997/10/22 T.Handa ver.1.00
2000/ 2/15 T.Handa ver.1.50 (add) PpsSetWholePageSize();
*/

#define	DVI_SCALE	(72.0)
#define	CM2INCH	(0.393701)

#define	N_PATT_LIST	128	/* Max number of LinePattern List */

typedef struct	{ double x, y; } PpsPoint;

#ifdef _NO_PROTO
extern void PpsGetScale();
extern void PpsGetOrigin();
extern void PpsSetPrinterName();
extern void PpsPutScale();
extern void PpsPutOrigin();
extern void PpsSetWholePageSize();

extern void PpsSetColor();
extern void PpsSetGray();
extern void PpsSetLinePattern();
extern void PpsSetLineWidth();
extern void PpsDrawLine();
extern void PpsDrawLines();
extern void PpsDrawRectangle();
extern void PpsDrawPolygon();
extern void PpsDrawArc();
extern void PpsDrawSector();

extern void PpsSetFont();
extern void PpsDrawString();
extern void PpsDrawJustifiedString();

extern void PpsPrintPage();
extern void PpsInitialize();
extern void PpsDoPrint();

#else
extern void PpsGetScale(double *, double *);
extern void PpsGetOrigin(double *, double *);
extern void PpsSetPrinterName(char *);
extern void PpsPutScale(double,double);
extern void PpsPutOrigin(double,double);
extern void PpsSetWholePageSize(double,double,double,double);

extern void PpsSetColor(char *);
extern void PpsSetGray(double);
extern void PpsSetLinePattern(double *,int,double);
extern void PpsSetLineWidth(double);
extern void PpsDrawLine(double,double,double,double);
extern void PpsDrawLines(PpsPoint *,int);
extern void PpsDrawRectangle(double,double,double,double,int);
extern void PpsDrawPolygon(PpsPoint *,int,int);
extern void PpsDrawArc(double,double,double,double,double,int);
extern void PpsDrawSector(double,double,double,double,double,int);

extern void PpsSetFont(char *,short);
extern void PpsDrawString(double,double,char *);
extern void PpsDrawJustifiedString(double,double,char *,char *,char *);

extern void PpsPrintPage(void);
extern void PpsInitialize(char *,double,double);
extern void PpsDoPrint(void);

#endif
