/*
PxpG -- Graph Plot for X11 window and/or Postscript printer

Library for X11 display and/or PostScript printer
1997/10/23 T.Handa ver.1.00
1998/ 5/18 T.Handa ver.1.01 (add) PxpGFilledBox()
2000/ 2/16 T.Handa ver.1.02 (add) PxpGEnclosureRange2InteriorRange()
*/

#define	DVI_SCALE	(72.0)
#define	CM2INCH	(0.393701)

#define	X11WIN	1
#define	POSTSCRIPT	2

#define	CARTESIAN	0
#define	CIRCULAR	1
#define	POLOAR	1
#define	SINUSOIDAL	2

#define	PI	3.1415926535897932385

typedef struct	{ double x, y; } PxpGPoint;

#define	PxpGGSetScale(x,y)	PxpGGPutScale((x),(y))
#define	PxpGGSetPlotOrigin(x,y)	PxpGGPutPlotOrigin((x),(y))
#define	PxpGGSetPhysicsOrigin(x,y)	PxpGGPutPhysicsOrigin((x),(y))

#ifdef _NO_PROTO
extern void PxpGGetScale();
extern void PxpGGetPlotOrigin();
extern void PxpGGetPhysicsOrigin();
extern void PxpGPutScale();
extern void PxpGPutPlotOrigin();
extern void PxpGPutPhysicsOrigin();
extern void PxpGSetRange();
extern PxpPoint PxpGPhysicsValue();
extern PxpPoint PxpGPlotPosition();
extern PxpPoint PxpGPhysicsSpan();
extern PxpPoint PxpGPlotSpan();

extern void PxpGBox();
extern void PxpGFilledBox();
extern void PxpGGrid();
extern void PxpGGridInset();
extern void PxpGTickMark();
extern void PxpGTickMarkInset();
extern void PxpGLabel();
extern void PxpGLabelInset();
extern void PxpGLine();
extern void PxpGLines();
extern void PxpGMark();
extern void PxpGErrorBar();
extern void PxpGErrorBarX();

extern void PxpGCeilingRange();
extern PxpRange PxpGEnclosureRange2InteriorRange();
extern void PxpGLabelFormat();

#else
extern void PxpGGetScale(double *,double *);
extern void PxpGGetPlotOrigin(double *,double* );
extern void PxpGGetPhysicsOrigin(double *,double *);
extern void PxpGPutScale(double,double);
extern void PxpGPutPlotOrigin(double,double);
extern void PxpGPutPhysicsOrigin(double,double);
extern void PxpGSetRange(PxpPoint,PxpPoint,PxpPoint,PxpPoint);
extern PxpPoint PxpGPhysicsValue(PxpPoint);
extern PxpPoint PxpGPlotPosition(PxpPoint);
extern PxpPoint PxpGPhysicsSpan(PxpPoint);
extern PxpPoint PxpGPlotSpan(PxpPoint);

extern void PxpGBox(PxpPoint,PxpPoint);
extern void PxpGFilledBox(PxpPoint,PxpPoint);
extern void PxpGGrid(PxpPoint,PxpPoint,double,double);
extern void PxpGGridInset(PxpPoint,PxpPoint,PxpPoint,PxpPoint,double,double);
extern void PxpGTickMark(PxpPoint,PxpPoint,double,double,double);
extern void PxpGTickMarkInset(PxpPoint,PxpPoint,PxpPoint,PxpPoint,
	double,double,double);
extern void PxpGLabel(PxpPoint,PxpPoint,double,double,char *, char *);
extern void PxpGLabelInset(PxpPoint,PxpPoint,PxpPoint,PxpPoint,double,double,
	char *, char *);
extern void PxpGLine(double,double,double,double);
extern void PxpGLines(PxpPoint *,int);
extern void PxpGMark(double,double,char *,double);
extern void PxpGErrorBar(double,double,double,double);
extern void PxpGErrorBarX(double,double,double,double);

extern void PxpGCeilingRange(PxpRange,PxpRange *,int *,double *);
extern PxpRange PxpGEnclosureRange2InteriorRange(PxpRange,PxpRange,double);
extern void PxpGLabelFormat(char *, PxpRange, double, char);

#endif
