/*
Pxp -- Plot for X11 window and/or Postscript printer

Library for X11 display and/or PostScript printer
1997/10/23 T.Handa ver.1.00
*/

#define	DVI_SCALE	(72.0)
#define	CM2INCH	(0.393701)

#define	X11WIN	1
#define	POSTSCRIPT	2

typedef struct	{ double x, y; } PxpPoint;
typedef struct	{ double min, max; } PxpRange;

#define	PxpSetScale(x,y)	PxpPutScale((x),(y))
#define	PxpSetOrigin(x,y)	PxpPutOrigin((x),(y))

#ifdef _NO_PROTO
extern void PxpSetPrinterName();
extern void PxpGetOutputMode();
extern void PxpPutOutputMode();
extern void PxpGetScale();
extern void PxpGetOrigin();
extern void PxpPutScale();
extern void PxpPutOrigin();

extern void PxpSetColor();
extern void PxpSetGray();
extern void PxpSetLineWidth();
extern void PxpSetLinePattern();
extern void PxpSetLineType();
extern void PxpDrawLine();
extern void PxpDrawLines();
extern void PxpDrawRectangle();
extern void PxpDrawPolygon();
extern void PxpDrawArc();
extern void PxpDrawSector();
extern void PxpDrawMark();

extern void PxpSetFont();
extern void PxpDrawString();
extern void PxpDrawJustifiedString();
extern void PxpDrawJustifiedText();

extern void PxpFlush();
extern void PxpDisplayAll();

extern void PxpPoint2Range();
extern void PxpRange2Point();

#else
extern void PxpSetPrinterName(char *);
extern void PxpGetOutputMode(int *);
extern void PxpPutOutputMode(int);
extern void PxpGetScale(double *, double *);
extern void PxpGetOrigin(double *, double *);
extern void PxpPutScale(double, double);
extern void PxpPutOrigin(double, double);

extern void PxpSetColor(char *);
extern void PxpSetGray(double);
extern void PxpSetLineWidth(double);
extern void PxpSetLinePattern(double *,int,double);
extern void PxpSetLineType(char *);
extern void PxpDrawLine(double, double, double, double);
extern void PxpDrawLines(PxpPoint *,int);
extern void PxpDrawRectangle(double,double,double,double,int);
extern void PxpDrawPolygon(PxpPoint *,int,int);
extern void PxpDrawArc(double,double,double,double,double,int);
extern void PxpDrawSector(double,double,double,double,double,int);
extern void PxpDrawMark(double,double,char *,double);

extern void PxpSetFont(char *,short);
extern void PxpDrawString(double, double, char *);
extern void PxpDrawJustifiedString(double, double, char *, char *, char *);
extern void PxpDrawJustifiedText(double, double, char *, char *, char *);

extern void PxpFlush(void);
extern void PxpDisplayAll(int, char **, int, char *,
	char *,double,double,void (*)(),void (*)(),void (*)());

extern void PxpPoint2Range(PxpPoint, PxpPoint, PxpRange *, PxpRange *);
extern void PxpRange2Point(PxpRange, PxpRange, PxpPoint *, PxpPoint *);
#endif
