/*
Pxx -- Plot for X11 Window

Library for X11 display
1997/10/23 T.Handa ver.1.00
1997/12/04 T.Handa ver.1.00 (debug for NewsC)
1997/12/09 T.Handa ver.1.01 (add) PxxPresentWindowSize();
2000/ 2/20 T.Handa ver.1.51 (add) PxxRange,PxxRange_long;
2000/ 2/24 T.Handa ver.1.60 (add) 
*/

#define	DVI_SCALE	(72.0)
#define	CM2INCH	(0.393701)

#define	N_PATT_LIST	128	/* Max number of LinePattern List */

#define PxxDIRECT_COLOR_MODEL 2
#define PxxINDEX_COLOR_MODEL 1

typedef struct	{ double x, y; } PxxPoint;
typedef struct	{ double min, max; } PxxRange;
typedef struct { long min, max; } PxxRange_long;
typedef struct { double red,green,blue; } PxxRGBcolor;
typedef struct { unsigned long red,green,blue; } PxxRGBcolor_long;
typedef struct { PxxRange_long red,green,blue; } PxxRGBrange;

#ifdef _NO_PROTO
extern void PxxSetPrinterName();
extern void PxxSetPSFName();

extern void	PxxGetPixelPosition();
extern void	PxxGetPlotPosition();
extern int	PxxGetPixelSpanX();
extern int	PxxGetPixelSpanY();
extern double	PxxGetPlotSpanX();
extern double	PxxGetPlotSpanY();

extern Display *PxxGetDisplay();
extern Window	PxxGetWindow();
extern GC	PxxGetGC();
extern void	PxxSetPlotFunction();
extern void	PxxSetExitFunction();
extern void	PxxSetHelpFunction();
extern void	PxxGetWindowSize();
extern void	PxxGetWindowSizeInPixel();
extern void	PxxGetScale();
extern void	PxxGetOrigin();
extern void	PxxPresentWindowSize();

extern Display *PxxPutDisplay();
extern Window	PxxPutWindow();
extern GC	PxxPutGC();
extern void	PxxPutWindowSizeInPixel();
extern void	PxxSetMaxStepsForFlush();
extern void	PxxPutScale();
extern void	PxxPutOrigin();

extern unsigned long PxxGetColorCode();
extern void PxxSetColor();
extern void PxxSetGray();
extern void PxxSetLineWidth();
extern void PxxSetLinePattern();
extern void PxxDrawLine();
extern void PxxDrawLines();
extern void PxxDrawRectangle();
extern void PxxDrawPolygon();
extern void PxxDrawArc();
extern void PxxDrawSector();

extern void PxxSetFont();
extern void PxxDrawString();
extern void PxxFlush();

extern void PxxExecPrintOut();
extern void PxxPushButtonActions();
extern void PxxExecDraw();
extern void PxxDisplayAll();

#else
extern void PxxSetPrinterName(char *);
extern void PxxSetPSFName(char *);

extern void	PxxGetPixelPosition(double, double, int *, int *);
extern void	PxxGetPlotPosition(int, int, double *, double *);
extern int	PxxGetPixelSpanX(double);
extern int	PxxGetPixelSpanY(double);
extern double	PxxGetPlotSpanX(int);
extern double	PxxGetPlotSpanY(int);

extern Display *PxxGetDisplay(void);
extern Window	PxxGetWindow(void);
extern GC	PxxGetGC(void);
extern void	PxxSetPlotFunction(void (*)());
extern void	PxxSetExitFunction(void (*)());
extern void	PxxSetHelpFunction(void (*)());
extern void	PxxGetWindowSize(double *, double *);
extern void	PxxGetWindowSizeInPixel(int *, int *);
extern void	PxxGetScale(double *, double *);
extern void	PxxGetOrigin(double *, double *);
extern void	PxxPresentWindowSize(int *, int *, int *, int *);

extern Display *PxxPutDisplay(Display *);
extern Window	PxxPutWindow(Window);
extern GC	PxxPutGC(GC);
extern void	PxxPutWindowSizeInPixel(int, int);
extern void	PxxSetMaxStepsForFlush(int);
extern void	PxxPutScale(double, double);
extern void	PxxPutOrigin(double, double);

extern unsigned long PxxGetColorCode(char *);
extern void PxxSetColor(char *);
extern void PxxSetGray(double);
extern void PxxSetLineWidth(double);
extern void PxxSetLinePattern(double *,int,double);
extern void PxxDrawLine(double,double,double,double);
extern void PxxDrawLines(PxxPoint *,int);
extern void PxxDrawRectangle(double,double,double,double,int);
extern void PxxDrawPolygon(PxxPoint *,int,int);
extern void PxxDrawArc(double,double,double,double,double,int);
extern void PxxDrawSector(double,double,double,double,double,int);

extern void PxxSetFont(char *);
extern void PxxDrawString(double,double,char *);
extern void PxxFlush(void);

extern void PxxExecPrintOut(void);
extern void PxxPushButtonActions(Widget,caddr_t,caddr_t);
extern void PxxExecDraw(Widget,GC,XmDrawingAreaCallbackStruct *);
extern void PxxDisplayAll(int, char **,char *,double,double,void (*)(),void (*)(),void (*)());

#endif

/* color pixmap */
#ifdef _NO_PROTO
extern XImage *PxxPixmapInitialize();
extern void PxxDrawCellOnXImage();
extern void PxxSetLevel2RGBcolorFunction();
extern void PxxLevel2RGBcolorStd();
extern unsigned long PxxRGBcolor2pixel();

#else
extern XImage *PxxPixmapInitialize(char *,unsigned int,unsigned int,unsigned int);
extern void PxxDrawCellOnXImage(XImage *,double,double,double,double,unsigned long);
extern void PxxSetLevel2RGBcolorFunction(void (*)());
extern void PxxLevel2RGBcolorStd(PxxRGBcolor *,double);
extern unsigned long PxxRGBcolor2pixel(PxxRGBcolor);
extern unsigned long PxxLevel2pixel(void (*)(),double);

#endif
